module Thrift
  module Struct
    def to_hash
      hash = {}
      each_field do |fid, field_info|
        name = field_info[:name]
        value = instance_variable_get("@#{name}")
        unless field_info[:optional] && value.nil?
          hash.store(name, value)
        end
      end
      return hash
    end
  end
end